;;;; This is free software.  See LICENSE for copyright information.

(module srfi-130
  (string-cursor? string-cursor-start string-cursor-end
   string-cursor-prev string-cursor-next
   string-cursor-forward string-cursor-back
   string-cursor=? string-cursor<? string-cursor>?
   string-cursor<=? string-cursor>=? string-cursor>?
   string-cursor-diff string-cursor->index string-index->cursor

   string-null? string-every string-any

   string-tabulate string-unfold string-unfold-right
   string->list/cursors string->vector/cursors
   reverse-list->string string-join

   string-ref/cursor substring/cursors string-copy/cursors
   string-take string-drop string-take-right string-drop-right
   string-pad string-pad-right
   string-trim string-trim-right string-trim-both

   string-prefix-length string-suffix-length
   string-prefix? string-suffix?

   string-index string-index-right string-skip string-skip-right
   string-contains string-contains-right

   string-reverse string-concatenate string-concatenate-reverse
   string-fold string-fold-right string-for-each-cursor
   string-replicate string-count string-replace
   string-split string-filter string-remove)

  (import scheme
          (except (chicken base) define-record-type define-record)
          (chicken condition)
          (chicken platform)
          (only (chicken string) substring-index string-intersperse)
          (chicken type)
          utf8-lolevel
          (only srfi-1 every last)
          (prefix (only (srfi 13) string-copy string-reverse) byte:)
          (srfi 143)
          typed-records
          (prefix utf8 utf8:)
          (prefix utf8-srfi-13 utf8:))

  (register-feature! 'srfi-130)

  (include "util.scm")
  (include "exceptions.scm")
  (include "130-impl-wcm.scm")
)
